//  piggy_01:EEPROMɂc/ǂݏo
//  CRpC[:CCS(PCM)
//  
//  }CR:PIC16F88(EEPROMe:256 byte)
//  
//  I/O info  //
//  LCD(SD1602) - PIC
//  ------------------
//  DB7 - RB0
//  DB6 - RB1
//  DB5 - RB2
//  DB4 - RB3
//  RS  - RB4
//  STB - RB5
//  
//  Reset SW:RB6(pull upL)
//  ԊOLED:RB7
//  tHgTr(RA0:PI(B)o, RA1:PI(A)d݌o, RA7:PI(C)o
//  2FLED(RA2:Red, RA4:Green)
//  RCT[{:RA6

#include  <16f88.h>
#fuses INTRC_IO,NOWDT,NOPROTECT,BROWNOUT,PUT,NOLVP,NOMCLR
#use delay(CLOCK = 4000000)		//NbNg=4MHz
#use fast_io(A)
#use fast_io(B)

// ϐ錾
long x;				// RCT[{ϐ
long y;				// cϐ
long data;			// EEPROMۑf[^ϐ
long Gopen=2000;		// RCT[{p[^[(Q[gJ)2000
long Gorgn=920;		// RCT[{p[^[(Q[g:_)920
long Gichi=1590;		// RCT[{p[^[(1~臒l)1590
long Ghyak=1700;		// RCT[{p[^[(100~臒l)1700
long Ggoju=1590;		// RCT[{p[^[(50~臒l)1590
long LSBW,MSBW;		// /8 bit(EEPROMݕϐ)
long LSBR,MSBR;		// /8 bit(EEPROMǂݏoϐ)

// vg^CsO錾
void Maintenance();	// eiXR[֐
void Sensing();		// d݌o(ԊOLED)֐
void display();		// LCD\֐
void RCSM();			// RCT[{֐
void Clear_EEPROM();	// EEPROMNA֐
void Wt_EEPROM();		// EEPROM݊֐
void Rd_EEPROM();		// EEPROMǂݏo֐

#define MAX_EEPROM 0x100	// EEPROMőAhX:0xFF

// t\Cuݒ
#define DB7	PIN_B0
#define DB6	PIN_B1
#define DB5	PIN_B2
#define DB4	PIN_B3
#define RS	PIN_B4
#define STB	PIN_B5
#include  <lcd_lib.c>

// C֐
void main()
{
	set_tris_a(0x83);		// RA7/1/0:input(tHgTr),:output
	set_tris_b(0x40);		// RB6:input,:output

	port_b_pullups(0x40);		// RB6(^NgSW):WPUL

	output_a(0);			// RA clear
	output_b(0);			// RB clear

	output_a(0x04);		// LED:Red(Busy)
	delay_ms(500);		// 0.5sec҂

	lcd_init();			// LCD
	lcd_clear();			// LCDر

	x = Gopen;		// RCT[{Open
	RCSM();

// tHgTrꂩON̏ꍇeiXR[
	Sensing();		// o

	while((input(PIN_A0)==0) || (input(PIN_A1)==0) || (input(PIN_A7)==0))
		Maintenance(); 

// C[`
	while(1)
	{
		Rd_EEPROM();			// EEPROMǂݏo
		y = data;				// c

 		if(!input(PIN_B6))          // ZbgSW ONŋz0Zbg
		{
			y = 0;				// c0Zbg
			Clear_EEPROM();		// EEPROMNA
			lcd_clear();

			while(!input(PIN_B6))       // SWĂƂҋ@ 
				delay_ms(25);           // `^O
		}

		display();		// LCD\

		x = Gorgn;		// RCT[{(_)ʒu
		RCSM();

		output_a(0x10);	// LED:Green(Ready)

		Sensing();	// o

		if(input(PIN_A1)==0)		// dݓȂ
		{
			output_a(0x04);		// LED:Red(Busy)
			delay_ms(1000);		// 1sec҂
		}

// d(1/10/100/500~)

		Sensing();	// o

		if((input(PIN_A1)==0) && (input(PIN_A0)==0))
		{
			output_a(0x04);		// Busy(LED:Red)

			x = Gichi;		// RCT[{1~臒lʒu
			RCSM();

			delay_ms(1000);		// 1sec҂

			Sensing();	// o

			if((input(PIN_A0)==0) && (input(PIN_A7)==1))	// 500~̏ꍇ
			{
				y += 500;
				Wt_EEPROM();		// EEPROMɎc
			}

			Sensing();	// o

			if((input(PIN_A0)==1) && (input(PIN_A7)==1))	// 1~̏ꍇ
			{
				y += 1;
				Wt_EEPROM();		// EEPROMɎc
			}

			Sensing();	// o

			if(input(PIN_A7)==0)		// 1~ȊO
			{
				x = Ghyak;		// RCT[{100~臒lʒu
				RCSM();

				delay_ms(1000);		// 1sec҂

				Sensing();	// o

				if(input(PIN_A7)==1)		// 100~̏ꍇ
				{
					y += 100;
					Wt_EEPROM();		// EEPROMɎc
				}

				Sensing();	// o

				if(input(PIN_A7)==0)		// 100~ȊO10~
				{
					y += 10;
					Wt_EEPROM();		// EEPROMɎc
				}
			}

			x = Gopen;			// RCT[{Jʒu
			RCSM();
			delay_ms(1000);		// 1sec҂
		}


// d(5~/50~)

		Sensing();	// o

		if((input(PIN_A1)==0) && (input(PIN_A0)==1))
		{
			output_a(0x04);		// LED:Red(Busy)

			x = Ggoju;		// RCT[{50~臒lʒu
			RCSM();

			delay_ms(1000);

			Sensing();	// o

			if(input(PIN_A7)==1)	// 50~̏ꍇ
			{
				y += 50;
				Wt_EEPROM();		// EEPROMɎc	
			}

			else			// 50~ȊO(=5~)
			{
				y += 5;
				Wt_EEPROM();		// EEPROMɎc	
			}

			x = Gopen;		// RCT[{J
			RCSM();
			delay_ms(1000);
		}
	}
}

// ---------------------------------------------------------------
void Maintenance()		// eiXR[֐
{
	output_a(0x04);
//	output_high(PIN_A2);	// Busy(LED:Red)    
    
	x = Gopen;			// RCT[{J
	RCSM();

	lcd_cmd(0x80);		// LCD1s
	printf(lcd_data, "Maintenance call");
}

// ---------------------------------------------------------------
void Sensing()			// d݌o(ԊOLED)֐
{
	int i;
	for(i=0; i<100; i++)
	{
		output_high(PIN_B7);		// 10kHzœ_
		delay_us(50);
		output_low(PIN_B7);
		delay_us(50);
	}
}

// ---------------------------------------------------------------
void display()			// LCD\֐
{
	lcd_cmd(0x80);		// LCD1s
	printf(lcd_data, "Let's save money");
	lcd_cmd(0xC0);		// LCD2s
	printf(lcd_data, "Bal.\\%Lu          ",y);	// y:10i\
}

// ---------------------------------------------------------------
void RCSM()				// RCT[{֐
{
	int i;
	for(i=1; i<=15; i++)
	{
		output_high(PIN_A6);
		delay_us(x);
		output_low(PIN_A6);
		delay_ms(18);
	}
	delay_ms(1000);
}

// ---------------------------------------------------------------
void Clear_EEPROM()		// EEPROMNA֐
{
	long address;
	for(address=0; address<MAX_EEPROM; address++)		// SAhX0x00
		write_eeprom(address, 0);
}

// ---------------------------------------------------------------
void Wt_EEPROM()		// EEPROM݊֐
{
	long address = 0;		// ݃AhXw
	LSBW = y & 0xFF;				// ỷ8 bitLSBWɊi[
	MSBW = (y >> 8) & 0xFF;		// x̏8 bitMSBWɊi[
	write_eeprom(address, LSBW);		// addressɉ8 bit
	write_eeprom(address+1, MSBW);		// address+1ɏ8 bit
}

// ---------------------------------------------------------------
void Rd_EEPROM()		// EEPROMǂݏo֐
{
	long address = 0;		// ǂݏoAhXw
	LSBR = read_eeprom(address);		// address牺8 bitf[^ǂݏo
	MSBR = read_eeprom(address+1);		// address+18 bitf[^ǂݏo
	data = (MSBR << 8) | LSBR;			// 8 bitƉ8 bitdataɊi[
}